var fs = require('fs');
var path = require('path');
var express = require('express');
var jsonRouter = require('./router/json');
var uploadRouter = require('./router/upload');
var router = express.Router();
// 全局跨域支持
router.use(function (req, res, next) {
    res.header('Access-Control-Allow-Origin', '*');
    res.header('Access-Control-Allow-Headers', 'Content-Type, Content-Length, Authorization, Accept, X-Requested-With , yourHeaderFeild');
    res.header('Access-Control-Allow-Methods', 'PUT, POST, GET, DELETE, OPTIONS');
    if (req.method === 'OPTIONS') {
        res.send(200);
    } else {
        next();
    }
});
// 请求信息显示
router.use(function (req, res, next) {
    console.log(["||", req.method, req.headers.host, req._parsedUrl.href, "||"].join(" "));
    next();
});
router.use("/res/upload", express.static('upload'));
// post test
router.use("/json", jsonRouter);
// 文件上传
router.use("/upload", uploadRouter);
router.get('/info', function (req, res) {
    res.send('<h1>Welcome RealTime Server</h1>');
});
module.exports = router;