/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/static";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = "./packages/interface/src/wdAjax.js");
/******/ })
/************************************************************************/
/******/ ({

/***/ "./packages/interface/src/wdAjax.js":
/*!******************************************!*\
  !*** ./packages/interface/src/wdAjax.js ***!
  \******************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; /**
                                                                                                                                                                                                                                                                               * tiny ajax
                                                                                                                                                                                                                                                                               * @param config
                                                                                                                                                                                                                                                                               */

// dependence


exports.default = ajax;

var _isWhat = __webpack_require__(/*! ../../utils/isWhat */ "./packages/utils/isWhat.js");

var _url = __webpack_require__(/*! ../../utils/url */ "./packages/utils/url.js");

var _objectOpt = __webpack_require__(/*! ../../utils/objectOpt */ "./packages/utils/objectOpt.js");

// default ajax params
var defaultOptions = {
    type: 'GET',
    url: '',
    data: null,
    // 只提供传统序列化方式
    traditional: true,
    dataType: 'json',
    jsonp: 'callback',
    contentType: 'application/x-www-form-urlencoded; charset=UTF-8',
    cache: true,
    success: new Function(),
    error: new Function(),
    uploading: new Function(),
    beforeSend: new Function(),
    dataFilter: null,
    headers: {
        "Accept": "application/json, text/javascript, */*; q=0.01",
        "Content-Type": "application/json; charset=UTF-8",
        "X-Requested-With": "XMLHttpRequest"
    }
};
//
var jsonpCounter = 100;

function ajax(config) {

    // init options
    var options = (0, _objectOpt.objCover)((0, _objectOpt.objClone)(defaultOptions), config);
    options.headers["Content-Type"] = options.contentType || options.headers["Content-Type"];

    // jsonp process
    function jsonpProcess() {
        // create receive func
        var jsonpCallbackName = 'jQuery21400015739046590903527_' + options.jsonp + jsonpCounter++;
        var called = false;
        window[jsonpCallbackName] = function (data) {
            called = true;
            callback(data);
        };
        // script tag
        var pageScript = document.createElement('script');
        pageScript.type = 'text/javascript';
        var params = (0, _objectOpt.objClone)(options.data);
        params[options.jsonp] = jsonpCallbackName;
        params["_"] = +new Date();
        pageScript.src = (0, _url.buildURL)({
            url: options.url,
            params: params
        });
        document.head.appendChild(pageScript);
        pageScript.onload = function () {
            if (called == false) {
                errCallback({
                    message: 'jsonp 返回结果不合法！'
                }, 'parsererror', {
                    status: 200,
                    readyState: 4
                });
            }
            delete window[jsonpCallbackName];
            document.head.removeChild(pageScript);
        };
        pageScript.onerror = function () {
            errCallback({
                message: '请求拒绝访问！'
            }, '(failed)net::ERR_CONNECTION_REFUSED', {
                status: null
            });
            document.head.removeChild(pageScript);
        };
    }

    // xhr process
    function xhrProcess() {
        var xhr = new XMLHttpRequest();
        /**
         * 上传状态
         */
        xhr.onreadystatechange = function () {
            // complete
            if (xhr.readyState == 4) {
                // success code 200
                if (xhr.status == 200) {
                    if ((0, _isWhat.isFunction)(options.dataFilter)) {
                        callback(options.dataFilter(xhr.responseText, xhr.responseType));
                    } else {
                        callback(xhr.responseText);
                    }
                } else {
                    errCallback(xhr.responseText, 'error', { status: xhr.status });
                }
            }
        };
        /**
         * 上传进度
         * @param {{loaded,total}} evt
         */
        xhr.upload.onprogress = function (evt) {
            var loaded = evt.loaded;
            var total = evt.total;
            var percent = Math.floor(100 * loaded / total);
            options.uploading && options.uploading(percent);
        };
        /**
         * 处理 xhr get
         */
        var xhrMethodGet = function xhrMethodGet() {
            // open
            xhr.open("GET", (0, _url.buildURL)({
                url: options.url,
                params: options.data
            }));
            // append headers
            Object.keys(options.headers).forEach(function (name) {
                xhr.setRequestHeader(name, options.headers[name]);
            });
            // before send hook
            options.beforeSend(xhr);
            // send
            xhr.send();
        };

        /**
         * 处理 xhr post
         */
        var xhrMethodPost = function xhrMethodPost() {
            xhr.open("post", options.url);
            // append headers
            Object.keys(options.headers).forEach(function (name) {
                xhr.setRequestHeader(name, options.headers[name]);
            });
            // before send hook
            options.beforeSend(xhr);
            xhr.send(serialDataToQuery(options.data));
        };

        // xhr method process
        var xhrMethod = {
            GET: function GET() {
                xhrMethodGet();
            },
            POST: function POST() {
                xhrMethodPost();
            }
        };
        xhrMethod[options.type.toUpperCase()]();
    }

    // select branch
    if (options.dataType.toLocaleLowerCase() === "jsonp") {
        jsonpProcess();
    } else {
        xhrProcess();
    }

    /**
     * 成功回调处理
     * @param resourceData
     */
    function callback(resourceData) {
        var dataPreProcessing = {
            json: function json() {
                return JSON.parse(resourceData);
            },
            jsonp: function jsonp() {
                return resourceData;
            },
            html: function html() {
                return resourceData;
            }
        };
        var dataType = options.dataType.toLocaleLowerCase();
        var data = void 0,
            eop = false;
        try {
            data = dataPreProcessing[dataType]();
        } catch (msg) {
            eop = true;
            errCallback({
                message: "[" + options.dataType + "]\u7C7B\u578B\u6570\u636E\u89E3\u6790\u5931\u8D25\uFF01"
            }, 'parsererror', {
                status: 200,
                response: resourceData,
                msg: msg
            });
        }
        // 不存在异常则进行成功回调
        !eop && options.success(data);
    }

    /**
     * 失败回调
     */
    var errCallback = options.error && options.error;

    /**
     * 序列化对象为字符串
     * 形式 : a=1&b=2
     * @param data
     * @returns {string}
     */
    function serialDataToQuery(data) {
        if ((0, _isWhat.isString)(data)) {
            return data;
        }
        if ((0, _isWhat.isObject)(data)) {
            var _ret = function () {
                var queryList = [];

                var _loop = function _loop(an) {
                    if (!data.hasOwnProperty(an)) return "continue";
                    if ((0, _isWhat.isArray)(data[an])) {
                        data[an].forEach(function (value) {
                            queryList.push(an + '=' + encodeURI(value));
                            // queryList.push(an + '=' + value);
                        });
                    } else {
                        queryList.push(an + '=' + encodeURI(data[an]));
                        // queryList.push(an + '=' + data[an]);
                    }
                };

                for (var an in data) {
                    var _ret2 = _loop(an);

                    if (_ret2 === "continue") continue;
                }
                return {
                    v: queryList.join('&')
                };
            }();

            if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;
        }
        console.error("暂时只支持对象作为数据！");
    }
};

/***/ }),

/***/ "./packages/utils/isWhat.js":
/*!**********************************!*\
  !*** ./packages/utils/isWhat.js ***!
  \**********************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
//=========================================================
//  类型检查
//=========================================================

function isType(type) {
    return function (obj) {
        return {}.toString.call(obj) === "[object " + type + "]";
    };
}

/**
 * 类型检查 Undefined
 * @function
 * @param {*} obj 检查目标
 * @global
 * @returns {boolean}
 * */
var isUndefined = isType("Undefined");
/**
 * 类型检查 Object
 * @function
 * @param {*} obj 检查目标
 * @global
 * @returns {boolean}
 * */
var isObject = isType("Object");
/**
 * 类型检查 Number
 * @function
 * @param {*} obj 检查目标
 * @global
 * @returns {boolean}
 * */
var isNumber = isType("Number");
/**
 * 类型检查 Array
 * @function
 * @param {*} obj 检查目标
 * @global
 * @returns {boolean}
 * */
var isArray = Array.isArray || isType("Array");
/**
 * 类型检查 Function
 * @function
 * @param {*} obj 检查目标
 * @global
 * @returns {boolean}
 * */
var isFunction = isType("Function");
/**
 * 类型检查 String 验证 字符串字面量 和 new String()
 * @param {*} obj 检查目标
 * @global
 * @returns {boolean}
 * */
var isString = function isString(obj) {
    return isType("String")(obj) || obj instanceof String;
};
/**
 * 类型检查 Element
 * @param {*} obj 检查目标
 * @global
 * @returns {boolean}
 * */
var isElement = function isElement(obj) {
    return (/^\[object HTML\w*Element]$/.test({}.toString.call(obj))
    );
};
/**
 * 类型检查 HTMLCollection NodeList
 * @param  {*} obj 检查目标
 * @global
 * @returns {boolean}
 * */
var isElementArray = function isElementArray(obj) {
    return {}.toString.call(obj) == '[object HTMLCollection]' || {}.toString.call(obj) == '[object NodeList]';
};
/**
 * 类型检查 TableElement {thead|tbody|tr|td|th...}
 * @param {*} obj 检查目标
 * @global
 * @returns {boolean}
 * */
var isTableElement = function isTableElement(obj) {
    return (/^\[object HTMLTable\w*Element]$/.test({}.toString.call(obj))
    );
};

//=========================================================
//  类型检查扩展
//=========================================================
/**
 * 多类型检查
 * 支持传入链式操作
 * @param variable 变量
 * @param {(object|Array)} options  [ function isString(){} , ... ] , { isString : function(){} , ... }
 * @param single 检查<strong>成功一次</strong>后退出
 * @returns {{}}
 * @global
 * @example
 *
 * isWhat(document.createElement('div')).isTypes(['string','element','array'],function () {
     *     console.log("str | elem |  array ");
     * }).isObject(function () {
     *     console.log("obj");
     * }).isString(function () {
     *     console.log("str2");
     * }).isEqual("peter",function () {
     *     console.log("peterE1");
     * },1).isEqual("peter",function () {
     *     console.log("peterE2");
     * });
 * // => str | elem |  array
 *
 */
var isWhat = function isWhat(variable, options, single) {
    // 类型检查名称
    var typeMap = {
        'isFunction': isFunction, // function 是关键字，不能用啦
        'array': isArray, 'isArray': isArray,
        'object': isObject, 'isObject': isObject,
        'undefined': isUndefined, 'isUndefined': isUndefined,
        'string': isString, 'isString': isString,
        'number': isNumber, 'isNumber': isNumber,
        'element': isElement, 'isElement': isElement,
        'elementArray': isElementArray, 'isElementArray': isElementArray,
        'tableElement': isTableElement, 'isTableElement': isTableElement,
        'isEqual': null, // 自定义检查
        "isTypes": null // 自定义检查
    };
    // ---1-->--2-->--3-->---
    // options : [ function isString(){} , ... ]
    single = single ? 1 : options && options.length;
    void (isArray(options) && Array.prototype.forEach.call(options, function (callback) {
        void (callback.name && typeMap[callback.name] && typeMap[callback.name](variable) && !function () {
            void (single-- && single >= 0 && callback());
        }());
    }));
    // options : { isString : function(){} , ... }
    void (isObject(options) && Object.forEachIn.call(options, function (callback, type) {
        void (type && typeMap[type] && typeMap[type](variable) && !function () {
            void (single-- && single >= 0 && callback());
        }());
    }));
    // ---1-->--{}.A()-->--{}.B()-->---
    var next = {};
    for (var an in typeMap) {
        if (!typeMap.hasOwnProperty(an)) continue;
        /**
         * @param {string} type
         * @param {...*} 之后的为可变参数
         */
        next[an] = function (type) {
            // 参数形式
            // 比较值cmpValue 成功回掉callback
            // 比较值cmpValue 成功回掉callback 成功后终结标记barrier
            // 成功回掉cmpValue 成功后终结标记callback
            return function (cmpData, callback, barrier) {
                // params : callback
                if (arguments.length === 1) callback = cmpData;
                // params : callback barrier
                if (arguments.length === 2 && !isFunction(callback)) {
                    barrier = callback;
                    callback = cmpData;
                }
                // isEqual处理
                if (type === "isEqual") {
                    variable == cmpData && callback();
                }
                // isType处理
                else if (type === "isTypes") {
                        // 检查类型数组中有对应值则返回
                        isArray(cmpData) && cmpData.slice(0).forEach(function (typeName) {
                            if (typeMap[typeName] && typeMap[typeName](variable)) {
                                callback();
                                cmpData.splice(0, cmpData.length);
                            }
                        });
                    }
                    // 普通类型检查处理
                    else if (typeMap[type](variable) && callback) {
                            callback();
                        }
                // 成功一次后终结处理
                if (barrier) {
                    for (var _an in next) {
                        if (!next.hasOwnProperty(_an)) continue;
                        next[_an] = function () {
                            return next;
                        };
                    }
                }
                return next;
            };
        }(an);
    }
    return next;
};

exports.isUndefined = isUndefined;
exports.isObject = isObject;
exports.isArray = isArray;
exports.isFunction = isFunction;
exports.isString = isString;
exports.isNumber = isNumber;
exports.isElement = isElement;
exports.isElementArray = isElementArray;
exports.isTableElement = isTableElement;
exports.isWhat = isWhat;

/***/ }),

/***/ "./packages/utils/objectOpt.js":
/*!*************************************!*\
  !*** ./packages/utils/objectOpt.js ***!
  \*************************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.objExtract = exports.objEqual = exports.objClear = exports.objCover = exports.setObjAttr = exports.getObjAttr = exports.objClone = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; //=========================================================
// Object Operate
//=========================================================


var _isWhat = __webpack_require__(/*! ./isWhat */ "./packages/utils/isWhat.js");

/**
 * 对象复制
 * 其中的成员如果为对象{object}，则也进行复制操作
 * @param {Object|Array|Number|String} obj 目标对象
 * @returns {*} 返回复制的对象
 * @memberof $wd
 */
function objClone(obj) {
    var newObj = {};
    if ((0, _isWhat.isArray)(obj)) {
        newObj = obj.map(function (e) {
            return objClone(e);
        });
        return newObj;
    }
    if ((0, _isWhat.isObject)(obj)) {
        for (var an in obj) {
            if (!obj.hasOwnProperty(an)) continue;
            if ((0, _isWhat.isArray)(obj[an])) newObj[an] = obj[an].slice();else newObj[an] = (0, _isWhat.isObject)(obj[an]) ? objClone(obj[an]) : obj[an];
        }
        return newObj;
    }
    return obj;
}

/**
 * 提取object对应路径的属性
 * @param data {object} 提取目标
 * @param path {string}提取路径 'a.b.c'
 * @returns {*} 如果找对对应路径的属性则返回属性值，找不到则返回undefined
 * @memberof $wd
 * @example
 *      // 示例
 *      let obj = {
     *         a: {
     *             ao: {
     *                aoo:100
     *             }
     *         }
     *      };
 *      $wd.getObjAttr(obj, 'a.ao');            // => {aoo:100}
 *      $wd.getObjAttr(obj, 'a.ao.aoo');        // => 100
 *      $wd.getObjAttr(obj, 'a.an.aoo');        // => undefined
 *
 */
function getObjAttr(data, path) {
    var result = data;
    if (!path) return result;
    try {
        path.split('.').forEach(function (name) {
            result = result[name];
        });
    } catch (e) {
        return;
    }
    return result;
}

/**
 * 设置object对应路径的属性
 * 如果中间路径不存在则自动创建
 * @param {object} data  设置目标
 * @param {string} path  设置路径 'a.b.c'
 * @param {*} value 设置的新值
 * @returns {*} 如果找对对应路径的属性则返回属性值
 * @memberof $wd
 * @example
 *
 *    $wd.setObjAttr({
     *       a: {a1:998},
     *       b: 2,
     *       c: {
     *           c1: 3
     *       }
     *    }, 'a.aa.aaa', 998);
 *
 *    // => { a:{aa:{aaa:998},a1:998},b:2...}
 */
function setObjAttr(data, path, value) {
    var result = data;
    if (!path) return result;
    try {
        path.split('.').forEach(function (name, index) {
            if (index == path.split('.').length - 1) {
                result[name] = value;
                return;
            }
            if (!(0, _isWhat.isObject)(result[name]) && !(0, _isWhat.isElement)(result[name] && !(0, _isWhat.isArray)(result[name]))) result[name] = {};
            result = result[name];
        });
    } catch (e) {
        return;
    }
    return data;
}

/**
 * 对象属性覆盖
 * @param {object} obj1 被覆盖对象 会被修改
 * @param {object} obj2 覆盖对象
 * @param {(string|function)=} process 处理每个覆盖属性的回调 可选参数 会使用函数返回值作为新值
 * @returns {object} 被覆盖处理后的对象
 * @memberof $wd
 * @example
 *
 *      // 示例
 *      let obj1 = {a:1,b:2},obj2={a:3,c:4};
 *      $wd.objCover(obj1,obj2);
 *      // => {a:3,b:2,c:4}
 *      // obj1 = {a:3,b:2,c:4}
 *
 */
function objCover(obj1, obj2, process) {
    for (var an in obj2) {
        if (!obj2.hasOwnProperty(an) || process === 'one-to-one' && !obj1.hasOwnProperty(an)) continue;
        obj1[an] = (0, _isWhat.isFunction)(process) ? process(obj2[an], an, obj1[an]) : obj2[an];
    }
    return obj1;
}

/**
 * 对象属性覆盖
 * @param {object} obj 清空的对象 会被修改
 * @param {Number} [degree=VeryBig] 清空的深度
 * @returns {object} 处理后的对象
 * @memberof $wd
 * @example
 *
 *      // 示例
 *      let obj1 = {a:1,b:2};
 *      $wd.objClear(obj1,obj2);
 *      // => {a:null,b:null}
 *      // obj1 = {a:null,b:null}
 *
 */
function objClear(obj, degree) {
    var searchDegree = degree >= 0 ? degree : -1 >>> 1;
    if (searchDegree < 1) return obj;
    if ((0, _isWhat.isObject)(obj)) {
        Object.keys(obj).forEach(function (pn) {
            if ((0, _isWhat.isObject)(obj[pn])) {
                objClear(obj[pn], degree - 1);
            } else if ((0, _isWhat.isArray)(obj[pn])) {
                obj[pn].splice(0, obj[pn].length);
            } else {
                obj[pn] = null;
            }
        });
    }
    return obj;
}

/**
 * 比较两个对象是否相等
 * 默认进行==比较 ""==false==[]
 * @param obj1 对象1
 * @param obj2 对象2
 * @param attr {(string|array)=} 对象属性   a,b,c ['a','b','c']
 * @returns {boolean}
 * @memberof $wd
 * @example
 *
 *      // 示例
 *      let obj1 = {a:1,b:2},obj2={a:1,c:2},obj3={a:2};
 *      $wd.objEqual(obj1,obj2);
 *      // => true
 *      $wd.objEqual(obj1,obj3);
 *      // => false
 *
 */
function objEqual(obj1, obj2, attr) {
    var attrList = [];
    if (obj1 === obj2) return true;
    if (!(0, _isWhat.isObject)(obj1) || !(0, _isWhat.isObject)(obj2)) return false;

    var _loop = function _loop(an) {
        if (attr) {
            if ((0, _isWhat.isString)(attr)) attrList = attr.split(",");
            if (attrList.filter(function (e) {
                return e == an;
            }).length <= 0) return 'continue';
        }
        if (!obj2.hasOwnProperty(an)) return 'continue';
        if (obj2[an] == obj1[an]) return 'continue';
        return {
            v: false
        };
    };

    for (var an in obj2) {
        var _ret = _loop(an);

        switch (_ret) {
            case 'continue':
                continue;

            default:
                if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
        }
    }
    return true;
}

/**
 * 对象属性提取
 * 现在主要用于构造提交的表单数据
 * @param {object} obj 被提取属性的目标对象 可以为对象的数组  [obj , ...]
 * @param {(string[]|string)} options 提取规则   数组 : [option , ...]  option: 'oldName=>newName' | 'oldName=newName' | 'oldName'   字符串 : 'oldName=>newName,oldName2=>newName2'
 * @param {(boolean)=} [except=false] 第二个配置项的属性列表是否为排除模式
 * @returns {object|Array.<object>} 使用提取属性构造的新对象或数组
 * @memberof $wd
 * @example
 *
 *      // 从对象中抽取数据
 *      let obj = {red:255,name:'peter'};
 *      $wd.objExtract(obj,["red=>colorRed","name=>lastName"]);     // => { colorRed:255,lastName:'peter' }
 *      $wd.objExtract(obj,"red=>colorRed,name"]);                  // => { colorRed:255,name:'peter' }
 *
 *      // 从对象数组中抽取数据
 *      let arr = [obj,obj];
 *      $wd.objExtract(obj,["red=>colorRed","lastName"]);           // => [{ colorRed:255,lastName:'peter' },{ colorRed:255,name:'peter' }]
 *
 *      // 自动生成路径
 *      $wd.objExtract({
     *             a: 1,
     *             b: { b1: 2 },
     *             c: 3
     *          },
 *          "a,b.b1=>bb1,c=>z.x.c.v.b.n.m"
 *      );
 *      // 结果如下 =>
 *      //      {
     *      //         a: 1,
     *      //         bb1: 2,
     *      //         z:{x:{c:{v:{b:{n:{m:3}}}}}}
     *      //      }
 *
 */
function objExtract(obj, options, except) {
    // 提取 对应名称的属性
    var result = [],
        temp = void 0,
        originObj = objClone(obj),
        originOpt = options;
    (0, _isWhat.isUndefined)(options) && (originOpt = []);
    // 支持 使用逗号分隔的字符串生成配置数组 "oldName=>newName , oldName=>newName"
    (0, _isWhat.isString)(options) && (temp = options) && (originOpt = options.split(','));
    // 支持 从数组提取对象数组 obj [{a:1},{a:2}]  => [{b:1},{b:2}]
    !(0, _isWhat.isArray)(obj) && (temp = originObj) && (originObj = []) && originObj.push(temp);
    originObj.forEach(function (unit) {
        // except pattern
        if (except) {
            temp = unit;
            originOpt.forEach(function (name) {
                delete temp[name];
            });
        }
        // extract pattern
        if (!except) {
            temp = {};
            originOpt.forEach(function (name) {
                var resolveReg = /([^=>,]+)=[>]?([^=>,]+)/; // 支持中文
                if (resolveReg.test(name)) {
                    // 支持 'oldName=>newName' 'oldName=newName'
                    var originName = resolveReg.exec(name)[1];
                    var replaceName = resolveReg.exec(name)[2];
                    !(0, _isWhat.isUndefined)(getObjAttr(unit, originName)) && setObjAttr(temp, replaceName, getObjAttr(unit, originName));
                } else {
                    // 支持 'name'
                    !(0, _isWhat.isUndefined)(getObjAttr(unit, name)) && setObjAttr(temp, name, getObjAttr(unit, name));
                }
            });
        }
        result.push(temp);
    });
    if (!(0, _isWhat.isArray)(obj)) return result[0];
    return result;
}

exports.objClone = objClone;
exports.getObjAttr = getObjAttr;
exports.setObjAttr = setObjAttr;
exports.objCover = objCover;
exports.objClear = objClear;
exports.objEqual = objEqual;
exports.objExtract = objExtract;

/***/ }),

/***/ "./packages/utils/url.js":
/*!*******************************!*\
  !*** ./packages/utils/url.js ***!
  \*******************************/
/*! no static exports found */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.buildURL = exports.parseURL = undefined;

var _isWhat = __webpack_require__(/*! ./isWhat */ "./packages/utils/isWhat.js");

var _objectOpt = __webpack_require__(/*! ./objectOpt */ "./packages/utils/objectOpt.js");

/**
 * 解析URL 返回 解析数据对象
 * @param {string} url 需要解析的URL
 * @return {{source: *, query, origin: (*|string|string), params: {}, hashQuery, hashParams: {}, protocol: (string|XML|void|*), host, port, file: (*|string), hash: (string|XML|void|*), path: (string|XML|void|*), relative: (*|string), segments: Array, rebuild: rebuild}}
 * @memberof $wd
 */
//=========================================================
//  URL解析
//=========================================================
function parseURL(url) {
    var a = document.createElement('a');
    a.href = url;
    return {
        source: url,
        query: a.search,
        origin: a.origin || a.href.match(/\w+:\/\/[^\/\\]+/),
        params: function () {
            var ret = {},
                seg = a.search.replace(/^\?/, '').split('&');
            if (seg == false) return {};
            seg.forEach(function (e, index, arr) {
                arr[index] = {
                    name: e.split('=')[0],
                    value: decodeURI(e.split('=')[1])
                };
            });
            seg.forEach(function (e) {
                var name = e.name;
                var obj = [];
                if (typeof ret[name] === 'undefined') {
                    seg.forEach(function (e) {
                        if (e.name === name) obj.push(e.value);
                    });
                    if (obj.length === 1) ret[name] = obj[0];else ret[name] = obj;
                }
            });
            return ret;
        }(),
        hashQuery: function () {
            return a.hash.match(/(?=\?).*/) && a.hash.match(/(?=\?).*/)[0] || "";
        }(),
        hashParams: function () {
            if (!/.*\?/.test(a.hash)) return {};
            var ret = {},
                seg = a.hash.replace(/.*\?/g, '').split('&');
            seg.forEach(function (e, index, arr) {
                arr[index] = {
                    name: e.split('=')[0],
                    value: decodeURIComponent(e.split('=')[1])
                };
            });
            seg.forEach(function (e) {
                var name = e.name;
                var obj = [];
                if (typeof ret[name] === 'undefined') {
                    seg.forEach(function (e) {
                        if (e.name === name) obj.push(e.value);
                    });
                    if (obj.length === 1) ret[name] = obj[0];else ret[name] = obj;
                }
            });
            return ret;
        }(),
        protocol: a.protocol.replace(':', ''),
        host: a.hostname,
        port: a.port,
        file: (a.pathname.match(/\/([^\/?#]+)$/i) || ['', ''])[1],
        hash: a.hash.replace('#', ''),
        path: a.pathname.replace(/^([^\/])/, '/$1'),
        relative: (a.href.match(/tps?:\/\/[^\/]+(.+)/) || ['', ''])[1],
        segments: a.pathname.replace(/^\//, '').split('/'),
        rebuild: function rebuild() {
            return buildURL({
                url: this.url,
                hash: this.hash,
                origin: this.origin,
                source: this.source,
                path: this.path,
                params: this.params
            });
        }
    };
}

/**
 * 构建URL
 * @param {object} options
 * @param {string} [options.url=]       具体url
 * @param {string} [options.hash=]      hash
 * @param {string} [options.origin=]    域名
 * @param {string} [options.source=]    source
 * @param {string} [options.path=]      路径
 * @param {object} [options.params=]    参数
 * @returns {string}
 */
function buildURL(options) {
    var urlInfo = parseURL(options.url || options.source);
    (0, _objectOpt.objCover)(urlInfo, (0, _objectOpt.objExtract)(options, "url", true));
    urlInfo.path = urlInfo.path.replace(/^(?=[^\/])/, '/');

    var paramsStr = "";
    Object.forEachIn.call(urlInfo.params, function (value, key) {
        if (value === null || value === undefined) return;
        if (!(0, _isWhat.isArray)(value)) value = [value];
        value.forEach(function (value) {
            if ((0, _isWhat.isObject)(value)) value = encodeURIComponent(JSON.stringify(value));
            paramsStr += (paramsStr ? "&" : "") + key + '=' + encodeURIComponent(value);
        });
    });

    return urlInfo.origin + urlInfo.path + (paramsStr ? "?" + paramsStr : "") + (urlInfo.hash ? "#" + urlInfo.hash : "");
}

exports.parseURL = parseURL;
exports.buildURL = buildURL;

/***/ })

/******/ });
